from src.models import (
    POHDistanceTable,
    POHRateOfClimb,
    POHTimeFuelDistanceToClimb,
    POHCruisePerformance,
)

c152_takeoff_distances = POHDistanceTable(
    temperatures=[0, 10, 20, 30, 40],
    pressure_altitude=[0, 1000, 2000, 3000, 4000, 5000, 6000, 7000, 8000],
    grass_factor=0.15,
    wind_correction=lambda head_wind: (
        1 - (0.1 * abs(head_wind / 9))
        if head_wind > 0
        else 1 + (0.1 * abs(head_wind / 2))
    ),
    ground_roll=[
        (640, 695, 755, 810, 875),
        (705, 765, 825, 890, 960),
        (775, 840, 910, 980, 1055),
        (855, 925, 1000, 1080, 1165),
        (940, 1020, 1100, 1190, 1285),
        (1040, 1125, 1215, 1315, 1420),
        (1145, 1245, 1345, 1455, 1570),
        (1270, 1375, 1490, 1615, 1745),
        (1405, 1525, 1655, 1795, 1940),
    ],
    screen_height=[
        (1190, 1290, 1390, 1495, 1605),
        (1310, 1420, 1530, 1645, 1770),
        (1445, 1565, 1690, 1820, 1960),
        (1600, 1730, 1870, 2020, 2185),
        (1775, 1920, 2080, 2250, 2440),
        (1970, 2140, 2320, 2525, 2750),
        (2200, 2395, 2610, 2855, 3125),
        (2470, 2705, 2960, 3255, 3590),
        (2800, 3080, 3395, 3765, 4195),
    ],
)
c152_landing_distances = POHDistanceTable(
    temperatures=[0, 10, 20, 30, 40],
    pressure_altitude=[0, 1000, 2000, 3000, 4000, 5000, 6000, 7000, 8000],
    grass_factor=0.45,
    wind_correction=lambda head_wind: (
        1 - (0.1 * abs(head_wind / 9))
        if head_wind > 0
        else 1 + (0.1 * abs(head_wind / 2))
    ),
    ground_roll=[
        (450, 465, 485, 500, 515),
        (465, 485, 500, 520, 535),
        (485, 500, 520, 535, 555),
        (500, 520, 540, 560, 575),
        (520, 540, 560, 580, 600),
        (540, 560, 580, 600, 620),
        (560, 580, 605, 625, 645),
        (585, 605, 625, 650, 670),
        (605, 630, 650, 675, 695),
    ],
    screen_height=[
        (1160, 1185, 1215, 1240, 1265),
        (1185, 1215, 1240, 1270, 1295),
        (1215, 1240, 1270, 1300, 1330),
        (1240, 1275, 1305, 1335, 1360),
        (1275, 1305, 1335, 1370, 1400),
        (1305, 1335, 1370, 1400, 1435),
        (1340, 1370, 1410, 1440, 1475),
        (1375, 1410, 1440, 1480, 1515),
        (1410, 1450, 1480, 1520, 1555),
    ],
)
c152_rate_of_climb = POHRateOfClimb(
    temperatures=[-20, 0, 20, 40],
    pressure_altitude=[0, 2000, 4000, 6000, 8000, 10000, 12000],
    climb_speed=[67, 66, 65, 63, 62, 61, 60],
    rate_of_climb=[
        (835, 765, 700, 630),
        (735, 670, 600, 535),
        (635, 570, 505, 445),
        (535, 475, 415, 355),
        (440, 380, 320, 265),
        (340, 285, 230, 175),
        (245, 190, 135, 85),
    ],
)
c152_time_fuel_distance_to_climb = POHTimeFuelDistanceToClimb(
    pressure_altitude=[
        0,
        1000,
        2000,
        3000,
        4000,
        5000,
        6000,
        7000,
        8000,
        9000,
        10000,
        11000,
        12000,
    ],
    temperatures=[15, 13, 11, 9, 7, 5, 3, 1, -1, -3, -5, -7, -9],
    climb_speed=[67, 66, 66, 65, 65, 64, 63, 63, 62, 62, 61, 61, 60],
    rate_of_climb=[715, 675, 630, 590, 550, 505, 465, 425, 380, 340, 300, 255, 215],
    time=[0, 1, 3, 5, 6, 8, 10, 13, 15, 18, 21, 25, 29],
    fuel_used=[0, 0.2, 0.4, 0.7, 0.9, 1.2, 1.4, 1.7, 2, 2.3, 2.6, 3, 3.4],
    distance=[0, 2, 3, 5, 7, 9, 12, 14, 17, 21, 25, 29, 34],
    temperature_correction=lambda isa_temperature, temperature: (
        1 + (0.1 * abs((temperature - isa_temperature) / 10))
        if temperature - isa_temperature >= 10
        else 1.0
    ),
)
c152_cruise_performance = POHCruisePerformance(
    pressure_altitude=[2000, 4000, 6000, 8000, 10000, 12000],
    isa_deviation=[-20, 0, 20],
    rpm=[2550, 2500, 2450, 2400, 2300, 2200, 2100, 2000],
    fairings_correction=2,
    brake_horse_power=[
        [
            (-9999, -9999, -9999),
            (-9999, -9999, -9999),
            (-9999, -9999, -9999),
            (-9999, 75, 70),
            (71, 66, 63),
            (62, 59, 56),
            (55, 53, 51),
            (49, 47, 46),
        ],
        [
            (-9999, -9999, -9999),
            (-9999, -9999, -9999),
            (-9999, 75, 70),
            (76, 71, 67),
            (67, 63, 60),
            (60, 56, 54),
            (53, 51, 49),
            (48, 46, 45),
        ],
        [
            (-9999, -9999, -9999),
            (-9999, 75, 71),
            (-9999, 71, 67),  # Median
            (72, 67, 64),
            (64, 60, 57),
            (57, 54, 52),
            (51, 49, 48),
            (46, 45, 44),
        ],
        [
            (-9999, 75, 71),
            (76, 71, 67),
            (72, 67, 64),  # Median
            (68, 64, 61),
            (61, 58, 55),
            (55, 52, 51),
            (49, 48, 46),
            (-9999, -9999, -9999),
        ],
        [
            (-9999, -9999, -9999),
            (72, 68, 64),
            (68, 64, 61),  # Median
            (65, 61, 58),
            (58, 56, 53),
            (53, 51, 49),
            (48, 46, 45),
            (-9999, -9999, -9999),
        ],
        [
            (-9999, -9999, -9999),
            (-9999, -9999, -9999),
            (65, 62, 59),
            (62, 59, 56),
            (56, 54, 52),
            (51, 49, 48),
            (47, 45, 44),
            (-9999, -9999, -9999),
        ],
    ],
    true_air_speed=[
        [
            (-9999, -9999, -9999),
            (-9999, -9999, -9999),
            (-9999, -9999, -9999),
            (-9999, 101, 101),
            (97, 96, 95),
            (92, 91, 90),
            (87, 86, 85),
            (81, 80, 79),
        ],
        [
            (-9999, -9999, -9999),
            (-9999, -9999, -9999),
            (-9999, 103, 102),
            (102, 101, 100),
            (96, 95, 95),
            (91, 90, 89),
            (86, 85, 84),
            (81, 80, 78),
        ],
        [
            (-9999, -9999, -9999),
            (-9999, 105, 104),
            (-9999, 102, 101),  # Median
            (101, 100, 99),
            (96, 95, 94),
            (90, 89, 88),
            (85, 84, 83),
            (80, 79, 77),
        ],
        [
            (-9999, 107, 106),
            (105, 104, 103),
            (102, 101, 100),  # Median
            (100, 99, 98),
            (95, 94, 93),
            (90, 89, 87),
            (84, 83, 82),
            (-9999, -9999, -9999),
        ],
        [
            (-9999, -9999, -9999),
            (105, 103, 103),
            (102, 100, 100),  # Median
            (99, 98, 97),
            (94, 93, 92),
            (89, 88, 86),
            (83, 82, 81),
            (-9999, -9999, -9999),
        ],
        [
            (-9999, -9999, -9999),
            (-9999, -9999, -9999),
            (101, 100, 99),
            (99, 97, 96),
            (93, 92, 91),
            (88, 87, 85),
            (82, 81, 79),
            (-9999, -9999, -9999),
        ],
    ],
    fuel_used=[
        [
            (-9999, -9999, -9999),
            (-9999, -9999, -9999),
            (-9999, -9999, -9999),
            (-9999, 6.1, 5.7),
            (5.7, 5.4, 5.1),
            (5.1, 4.8, 4.6),
            (4.5, 4.3, 4.2),
            (4.1, 3.9, 3.8),
        ],
        [
            (-9999, -9999, -9999),
            (-9999, -9999, -9999),
            (-9999, 6.1, 5.7),
            (6.1, 5.7, 5.4),
            (5.4, 5.1, 4.9),
            (4.8, 4.6, 4.4),
            (4.4, 4.2, 4),
            (3.9, 3.8, 3.7),
        ],
        [
            (-9999, -9999, -9999),
            (-9999, 6.1, 5.7),
            (-9999, 5.7, 5.4),  # Median
            (5.8, 5.4, 5.2),
            (5.2, 4.9, 4.7),
            (4.6, 4.4, 4.3),
            (4.2, 4, 3.9),
            (3.8, 3.7, 3.6),
        ],
        [
            (-9999, 6.1, 5.7),
            (6.2, 5.8, 5.4),
            (5.8, 5.5, 5.2),  # Median
            (5.5, 5.2, 4.9),
            (5, 4.7, 4.5),
            (4.5, 4.3, 4.2),
            (4.1, 3.9, 3.8),
            (-9999, -9999, -9999),
        ],
        [
            (-9999, -9999, -9999),
            (5.8, 5.5, 5.2),
            (5.5, 5.4, 5),  # Median
            (5.3, 5, 4.8),
            (4.7, 4.5, 4.4),
            (4.3, 4.2, 4),
            (4, 3.9, 3.8),
            (-9999, -9999, -9999),
        ],
        [
            (-9999, -9999, -9999),
            (-9999, -9999, -9999),
            (5.3, 5, 4.8),
            (5, 4.8, 4.6),
            (4.6, 4.4, 4.3),
            (4.2, 4.1, 4),
            (3.9, 3.8, 3.7),
            (-9999, -9999, -9999),
        ],
    ],
)
